﻿@remoteScope
Feature: Tag Remote Scope

Rule: Initialize & extend Tag Remote Scope

@tc:1450
Scenario: Linked test cases are added to Tag Remote Scope
	Given there is a remote server project
	And the synchronizer is configured as
		| setting           | value    |
		| remote/scope/type | tag      |
		| configurationKey  | Config01 |
	And there are scenarios in the local repository as
		| scenario   |
		| Scenario 1 |
		| Scenario 2 |
	When the local repository is synchronized with push
	Then the Test Case "Scenario: Scenario 1" should contain the following tags: "specsync:Config01"
	And the Test Case "Scenario: Scenario 2" should contain the following tags: "specsync:Config01"
	And the remote scope should contain the following Test Cases
		| test case            |
		| Scenario: Scenario 1 |
		| Scenario: Scenario 2 |

@tc:1451
@diag:hash
Scenario: The local test case did not change
	Given there is a remote server project
	And the synchronizer is configured as
		| setting           | value    |
		| remote/scope/type | tag      |
		| configurationKey  | Config01 |
	And there is an existing synchronized feature file
		"""
		Feature: My Feature
		
		@tc:[id-of-test-case]
		Scenario: Scenario 1
			When I do something
		"""
	When the local repository is synchronized with push
	Then the Test Case should not be changed
	And the output should contain "Hash: Detected push action: 'UpToDate'"

@tc:1452
@diag:hash
Scenario: Pull does not restore scope tag
	Given there is a remote server project
	And the synchronizer is configured as
		| setting                      | value    |
		| remote/scope/type            | tag      |
		| configurationKey             | Config01 |
		| synchronization/pull/enabled | true     |
	And there is an existing synchronized feature file
		"""
		Feature: Sample feature

		@tc:[id-of-test-case]
		@sometag
		Scenario: Sample scenario
			When something happens with someone
		"""
	When the Test Case title is updated to 'Scenario: Updated scenario'
	And the local repository is synchronized with pull
	Then the feature file in the local repository should be updated to:
		"""
		Feature: Sample feature

		@tc:[id-of-test-case]
		@sometag
		Scenario: Updated scenario
			When something happens with someone
		"""

@tc:1453
@diag:hash
Scenario: The scope tag is restored after a manual tag deletion
	Given there is a remote server project
	And the synchronizer is configured as
		| setting                      | value    |
		| remote/scope/type            | tag      |
		| configurationKey             | Config01 |
	And there is an existing synchronized feature file
		"""
		Feature: Sample feature

		@tc:[id-of-test-case]
		@someTag
		Scenario: Sample scenario
			When something happens with someone
		"""
	When the Test Case tags are updated to "someTag"
	And the local repository is synchronized with push
	Then the Test Case should contain the following tags: "specsync:Config01"


Rule: Remove Test Cases from Tag Remote Scope

@tc:1454
Scenario: The Test Case of a deleted scenario is removed from Tag Remote Scope
	Given there is a remote server project
	And the synchronizer is configured as
		| setting           | value    |
		| remote/scope/type | tag      |
		| configurationKey  | Config01 |
	And there is an existing synchronized feature file
		"""
		Feature: My Feature
		
		@tc:[id-of-test-case-1]
		Scenario: Scenario 1
			When I do something
		
		@tc:[id-of-test-case-2]
		Scenario: Scenario 2
			When I do something
		"""
	When the feature file is updated to:
		"""
		Feature: My Feature
		
		# Scenario 1 deleted
		
		@tc:[id-of-test-case-2]
		Scenario: Scenario 2
			When I do something
		"""
	And the local repository is synchronized with push
	Then the remote scope should contain the following Test Cases
		| test case            |
		| Scenario: Scenario 2 |
