﻿@remoteScope @adoSpecific
Feature: Test Suite Remote Scope

Rule: Initialize & extend Test Suite Remote Scope

@tc:261
Scenario: Linked test cases are added to a new Test Suite Remote Scope
	Given there is an Azure DevOps project
	And the synchronizer is configured as
		| setting                     | value            |
		| remote/scope/type           | testSuite        |
		| remote/scope/testSuite/name | RemoteScopeSuite |
	And there is a feature file in the local repository
		"""
		Feature: My Feature
		Scenario: Scenario 1
			When I do something
		Scenario: Scenario 2
			When I do something
		"""
	When the local repository is synchronized with push
	Then the Test Suite "RemoteScopeSuite" should be created
	And the Test Suite "RemoteScopeSuite" should contain the following Test Cases
		| test case            |
		| Scenario: Scenario 1 |
		| Scenario: Scenario 2 |

@tc:262
@bypass-integration
Scenario: Handles legacy sconfiguration
	If 'remote/testSuite' is specified, SpecSync automatically treats it as 
	'testSuite' remote scope without specifying 'remote/scope/type', but a 
	warning is displayed.
	Given there is an Azure DevOps project
	And the synchronizer is configured as
		| setting               | value            |
		| remote/testSuite/name | RemoteScopeSuite |
	And there is a feature file in the local repository
		"""
		Feature: My Feature
		Scenario: Scenario 1
			When I do something
		"""
	When the local repository is synchronized with push
	Then the Test Suite "RemoteScopeSuite" should be created
	But the synchronization should finish with warnings

Rule: Remove Test Cases from Test Suite Remote Scope

@tc:972
Scenario: The Test Case of a deleted scenario is removed from the Test Suite
	Given there is an Azure DevOps project with an empty Test Suite 'RemoteScopeSuite'
	And the synchronizer is configured as
		| setting                     | value            |
		| remote/scope/type           | testSuite        |
		| remote/scope/testSuite/name | RemoteScopeSuite |
	And there is an existing synchronized feature file
		"""
		Feature: My Feature

		@tc:[id-of-test-case]
		Scenario: Scenario 1
			When I do something
		"""
	When the feature file is updated to:
		"""
		Feature: My Feature

		# Scenario 1 deleted
		"""
	And the local repository is synchronized with push
	Then the Test Suite "RemoteScopeSuite" should be empty

Rule: The Test Suite Remote Scope is not modified with dry-run mode

@tc:594
@bypass-integration
Scenario: A scenario that was not included in a Test Suite is pushed in dry-run mode
	Given there is an Azure DevOps project with an empty Test Suite 'RemoteScopeSuite'
	And there is an existing synchronized scenario
		"""
		Scenario: Sample scenario
			When I do something
		"""
	And the synchronizer is configured as
		| setting                     | value            |
		| remote/scope/type           | testSuite        |
		| remote/scope/testSuite/name | RemoteScopeSuite |
	When the local repository is synchronized with push in dry-run mode
	Then the Test Suite "RemoteScopeSuite" should be empty
